package com.example.tmap_test

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.example.tmap_test.databinding.ListItemBinding

class CapybarasAdapter(
    private val context: Context,
    private val data: MutableList<CapybaraItem>,
    private val itemClickListener: CapybaraItemClickListener
): RecyclerView.Adapter<CapybarasAdapter.ListItemViewHolder>() {

    inner class ListItemViewHolder(private val binding: ListItemBinding): RecyclerView.ViewHolder(binding.root) {
        fun bind(item: CapybaraItem) {
            binding.ivListItem.setImageResource(item.imageId)
            binding.tvListItem.text = item.name

            binding.root.setOnClickListener {
                itemClickListener.onCapybaraItemClick(item)
            }
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ListItemViewHolder {
        return ListItemViewHolder(ListItemBinding.inflate(LayoutInflater.from(context), parent, false))
    }

    override fun onBindViewHolder(holder: ListItemViewHolder, position: Int) {
        val item = data[position]
        holder.bind(item)
    }

    override fun getItemCount(): Int = data.size
}