package com.example.tmap_test

import android.content.Context
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.content.edit
import androidx.fragment.app.Fragment
import com.example.tmap_test.Constants.Companion.SHARED_PREFS_NAME
import com.example.tmap_test.Constants.Companion.SHARED_PREFS_SHOW_SNACKBAR_KEY
import com.example.tmap_test.databinding.SettingsFragmentBinding
import com.google.android.material.snackbar.Snackbar

class SettingsFragment : Fragment() {
    private var _binding: SettingsFragmentBinding? = null
    private val binding get() = _binding!!

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View {
        _binding = SettingsFragmentBinding.inflate(inflater, container, false)

        return binding.root
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        loadSettings()

        binding.cbSnackbarAdded.setOnCheckedChangeListener { _, isChecked ->
            getSharedPrefs()?.edit {
                putBoolean(SHARED_PREFS_SHOW_SNACKBAR_KEY, isChecked)
                apply()
            }

            Snackbar.make(binding.root, getString(R.string.settings_updated), Snackbar.LENGTH_SHORT).show()
        }
    }

    private fun loadSettings() {
        val showSnackBar = getSharedPrefs()?.getBoolean(SHARED_PREFS_SHOW_SNACKBAR_KEY, false) ?: false
        binding.cbSnackbarAdded.isChecked = showSnackBar
    }

    private fun getSharedPrefs() = activity?.getSharedPreferences(SHARED_PREFS_NAME, Context.MODE_PRIVATE)
}